#ifndef Map_H
#define Map_H

#include <Bild.h>
#include "Spieler.h"
#include <Random.h>
#include "../../../Include/KSGKlientV.h"

using namespace Framework;

class Map
{
private:
	RCArray< Spieler > *gegner;
	RCArray< Spieler > *ziele;
	Spieler *spieler;
	LRahmen *feld;
	LRahmen *kam;
	LRahmen *map;
	int kamX;
	int kamY;
	int score;
	int breite;
	int hhe;
	int geschwindigkeit;
	int zAnzahl;
	int neuGegner;
	bool beendet;
    double gameTime;
    Datei capture;
    Critical cs;
    MinigameKlientV *klient;
    RandomGenerator *rGen;
    char tastenStnde;
	int ref;

public:
	// Konstruktor
	Map( MinigameKlientV *klient );
	// Destruktor
	~Map();
	// nicht constant
	void reset( Text *zOptionen );
	void doMausEreignis( MausEreignis &me );
	void doTastaturEreignis( TastaturEreignis &te );
	bool tick( double tickVal );
	void render( Bild &zRObj );
    void speichern();
	// constant
	int getScore() const;
	bool istBeendet() const;
	// Reference Counting
	Map *getThis();
	Map *release();
};

#endif